# DD4hep (Detector Description for High Energy Physics)
[![Build Status](https://travis-ci.org/AIDASoft/DD4hep.svg?branch=master)](https://travis-ci.org/AIDASoft/DD4hep)
[![pipeline status](https://gitlab.cern.ch/CLICdp/DetectorSoftware/DD4hep/badges/master/pipeline.svg)](https://gitlab.cern.ch/CLICdp/DetectorSoftware/DD4hep/commits/master)
[![Coverity Status](https://scan.coverity.com/projects/10713/badge.svg)](https://scan.coverity.com/projects/DD4hep)
[![DOI](https://zenodo.org/badge/60682190.svg)](https://zenodo.org/badge/latestdoi/60682190)

DD4hep is a software framework for providing a complete solution for full detector description (geometry, materials, visualization, readout, alignment, calibration, etc.) for the full experiment life cycle (detector concept development, detector optimization, construction, operation). It offers a consistent description through a single source of detector information for simulation, reconstruction, analysis, etc. It distributed under the [GPLv3 License](http://www.gnu.org/licenses/gpl-3.0.en.html)

[![License](https://www.gnu.org/graphics/gplv3-127x51.png)](https://www.gnu.org/licenses/gpl-3.0.en.html)

## Pre-requisites and installation
For information about how to install DD4hep see [this page](https://dd4hep.web.cern.ch/dd4hep/page/installation/)

## Documentation
Use's Manuals can be found [here](https://dd4hep.web.cern.ch/dd4hep/page/users-manual/).

The Code Reference can be found [here](https://dd4hep.web.cern.ch/dd4hep/reference/).

## Release notes
Comprehensive release notes can be found under `doc/ReleaseNotes.md`


